/* -*- C++ -*-
 *
 * Simple KDE app to test if kwm is able to log out even when programs
 * are hanging.
 *
 * The task is simple.  Tell the window manager that we handle session
 * management, and hang on request to save current setup.
 *
 * To test if the bug is still there, start this program, and try to
 * log out from KDE.
 */

#include <unistd.h> // for sleep()
#include <iostream.h> // for cout

#include <kapp.h>
#include <qpushbutton.h>

#include "hanger.h"

void myhanger::saveProperties(KConfig *config)
{
  cout << "Entering saveProperties()" << endl;
  /* This sleep triggers bug in kwm */
  sleep(2000);
}

myhanger::myhanger()
{
  QPushButton *hang = new QPushButton("Hang program");
  hang->resize(100,100);
  hang->show();
  setView(hang);
}

int
main(int argc, char *argv[])
{
  KApplication app(argc, argv, "hanging");
  myhanger hanger;
  app.enableSessionManagement(TRUE);
  app.setWmCommand("stop");


  app.setMainWidget(&hanger);
  app.exec();
}
